diff options
author | Jenkins <jenkins@review.openstack.org> | 2016-02-24 18:46:05 +0000 |
---|---|---|
committer | Gerrit Code Review <review@openstack.org> | 2016-02-24 18:46:05 +0000 |
commit | a10e41e38b7752b9ea414f62e89c998c0d0702ea (patch) | |
tree | b909d7e675f53a34195c2dd3ae39852e3ca7b70b /validation-scripts/all-nodes.sh | |
parent | 9e473e4b54197811ede59b07bfb3d0e79475e2e1 (diff) | |
parent | 45be848991eb2da0ed039dcaa457800b8ed3f314 (diff) |
Merge "Adds v6 capability to the deploy validation test (pings)"
Diffstat (limited to 'validation-scripts/all-nodes.sh')
-rw-r--r-- | validation-scripts/all-nodes.sh | 34 |
1 files changed, 18 insertions, 16 deletions
diff --git a/validation-scripts/all-nodes.sh b/validation-scripts/all-nodes.sh index 8057f201..ae1fddf3 100644 --- a/validation-scripts/all-nodes.sh +++ b/validation-scripts/all-nodes.sh @@ -5,23 +5,25 @@ # attempt a ping test the remote network IP. function ping_controller_ips() { local REMOTE_IPS=$1 - for REMOTE_IP in $(echo $REMOTE_IPS | sed -e "s| |\n|g" | sort -u); do - - for LOCAL_NETWORK in $(ip r | grep -v default | cut -d " " -f 1); do - local LOCAL_CIDR=$(echo $LOCAL_NETWORK | cut -d "/" -f 2) - local LOCAL_NETMASK=$(ipcalc -m $LOCAL_NETWORK | grep NETMASK | cut -d "=" -f 2) - local REMOTE_NETWORK=$(ipcalc -np $REMOTE_IP $LOCAL_NETMASK | grep NETWORK | cut -d "=" -f 2) - - if [ $REMOTE_NETWORK/$LOCAL_CIDR == $LOCAL_NETWORK ]; then - echo -n "Trying to ping $REMOTE_IP for local network $LOCAL_NETWORK..." - if ! ping -W 300 -c 1 $REMOTE_IP &> /dev/null; then - echo "FAILURE" - echo "$REMOTE_IP is not pingable. Local Network: $LOCAL_NETWORK" >&2 - exit 1 - fi - echo "SUCCESS" - fi + if [[ $REMOTE_IP =~ ":" ]]; then + networks=$(ip -6 r | grep -v default | cut -d " " -f 1 | grep -v "unreachable") + ping=ping6 + else + networks=$(ip r | grep -v default | cut -d " " -f 1) + ping=ping + fi + for LOCAL_NETWORK in $networks; do + in_network=$(python -c "import ipaddr; net=ipaddr.IPNetwork('$LOCAL_NETWORK'); addr=ipaddr.IPAddress('$REMOTE_IP'); print(addr in net)") + if [[ $in_network == "True" ]]; then + echo -n "Trying to ping $REMOTE_IP for local network $LOCAL_NETWORK..." + if ! $ping -W 300 -c 1 $REMOTE_IP &> /dev/null; then + echo "FAILURE" + echo "$REMOTE_IP is not pingable. Local Network: $LOCAL_NETWORK" >&2 + exit 1 + fi + echo "SUCCESS" + fi done done } |